Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34921)
@@ -1175,12 +2548,389 @@
         Flags => ['Binary','Unknown'],
     },
-    pitm => {
+    pitm => [{
         Name => 'PrimaryItemReference',
-        Flags => ['Binary','Unknown'],
-    },
+        Condition => '$$valPt =~ /^\0/', # (version 0?)
+        RawConv => '$$self{PrimaryItem} = unpack("x4n",$val)',
+        WriteHook => sub { my ($val,$et) = @_; $$et{PrimaryItem} = unpack("x4n",$val); },
+    },{
+        Name => 'PrimaryItemReference',
+        RawConv => '$$self{PrimaryItem} = unpack("x4N",$val)',
+        WriteHook => sub { my ($val,$et) = @_; $$et{PrimaryItem} = unpack("x4N",$val); },
+    }],
     free => { #PH
         Name => 'Free',
         Flags => ['Binary','Unknown'],
     },
+    iprp => {
+        Name => 'ItemProperties',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::ItemProp' },
+    },
+    iref => {
+        Name => 'ItemReference',
+        # the version is needed to parse some of the item references
+        Condition => '$$self{ItemRefVersion} = ord($$valPt); 1',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::QuickTime::ItemRef',
+            Start => 4,
+        },
+    },
+    idat => {
+        Name => 'MetaImageSize', #PH (NC)
+        Format => 'int16u',
+        # (don't know what the first two numbers are for)
+        PrintConv => '$val =~ s/^(\d+) (\d+) (\d+) (\d+)/${3}x$4/; $val',
+    },
+    uuid => [
+        { #PH (Canon R5/R6 HIF)
+            Name => 'MetaVersion', # (NC)
+            Condition => '$$valPt=~/^\x85\xc0\xb6\x87\x82\x0f\x11\xe0\x81\x11\xf4\xce\x46\x2b\x6a\x48/',
+            RawConv => 'substr($val, 0x14)',
+        },
+        {
+            Name => 'UUID-Unknown',
+            %unknownInfo,
+        },
+    ],
+);
+
+# additional metadata container (ref ISO14496-12:2015)
+%Image::ExifTool::QuickTime::OtherMeta = (
+    PROCESS_PROC => \&ProcessMOV,
+    WRITE_PROC => \&WriteQuickTime,
+    GROUPS => { 2 => 'Video' },
+    mere => {
+        Name => 'MetaRelation',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::MetaRelation' },
+    },
+    meta => {
+        Name => 'Meta',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::Meta' },
+    },
+);
+
+# metabox relation (ref ISO14496-12:2015)
+%Image::ExifTool::QuickTime::MetaRelation = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 2 => 'Video' },
+    FORMAT => 'int32u',
+    # 0 => 'MetaRelationVersion',
+    # 1 => 'FirstMetaboxHandlerType',
+    # 2 => 'FirstMetaboxHandlerType',
+    # 3 => { Name => 'MetaboxRelation', Format => 'int8u' },
+);
+
+%Image::ExifTool::QuickTime::ItemProp = (
+    PROCESS_PROC => \&ProcessMOV,
+    WRITE_PROC => \&WriteQuickTime,
+    GROUPS => { 2 => 'Image' },
+    ipco => {
+        Name => 'ItemPropertyContainer',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::ItemPropCont' },
+    },
+    ipma => {
+        Name => 'ItemPropertyAssociation',
+        RawConv => \&ParseItemPropAssoc,
+        WriteHook => \&ParseItemPropAssoc,
+        Notes => 'parsed, but not extracted as a tag',
+    },
+);
+
+%Image::ExifTool::QuickTime::ItemPropCont = (
+    PROCESS_PROC => \&ProcessMOV,
+    WRITE_PROC => \&WriteQuickTime,
+    PERMANENT => 1, # (can't be deleted)
+    GROUPS => { 2 => 'Image' },
+    VARS => { START_INDEX => 1 },   # show verbose indices starting at 1
+    colr => [{
+        Name => 'ICC_Profile',
+        Condition => '$$valPt =~ /^(prof|rICC)/',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::ICC_Profile::Main',
+            Start => 4,
+        },
+    },{
+        Name => 'ColorRepresentation',
+        ValueConv => 'join(" ", substr($val,0,4), unpack("x4n*",$val))',
+    }],
+    irot => {
+        Name => 'Rotation',
+        Format => 'int8u',
+        Writable => 'int8u',
+        Protected => 1,
+        ValueConv => '$val * 90',
+        ValueConvInv => 'int($val / 90 + 0.5)',
+    },
+    ispe => {
+        Name => 'ImageSpatialExtent',
+        Condition => '$$valPt =~ /^\0{4}/',     # (version/flags == 0/0)
+        RawConv => q{
+            my @dim = unpack("x4N*", $val);
+            return undef if @dim < 2;
+            unless ($$self{DOC_NUM}) {
+                $self->FoundTag(ImageWidth => $dim[0]);
+                $self->FoundTag(ImageHeight => $dim[1]);
+            }
+            return join ' ', @dim;
+        },
+        PrintConv => '$val =~ tr/ /x/; $val',
+    },
+    pixi => {
+        Name => 'ImagePixelDepth',
+        Condition => '$$valPt =~ /^\0{4}./s',   # (version/flags == 0/0 and count)
+        RawConv => 'join " ", unpack("x5C*", $val)',
+    },
+    auxC => {
+        Name => 'AuxiliaryImageType',
+        Format => 'undef',
+        RawConv => '$val = substr($val, 4); $val =~ s/\0.*//s; $val',
+    },
+    pasp => {
+        Name => 'PixelAspectRatio',
+        Format => 'int32u',
+        Writable => 'int32u',
+        Protected => 1,
+    },
+    rloc => {
+        Name => 'RelativeLocation',
+        Format => 'int32u',
+        RawConv => '$val =~ s/^\S+\s+//; $val', # remove version/flags
+    },
+    clap => {
+        Name => 'CleanAperture',
+        Format => 'rational64s',
+        Notes => '4 numbers: width, height, left and top',
+    },
+    hvcC => {
+        Name => 'HEVCConfiguration',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::HEVCConfig' },
+    },
+    av1C => {
+        Name => 'AV1Configuration',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::AV1Config' },
+    },
+);
+
+# HEVC configuration (ref https://github.com/MPEGGroup/isobmff/blob/master/IsoLib/libisomediafile/src/HEVCConfigAtom.c)
+%Image::ExifTool::QuickTime::HEVCConfig = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 2 => 'Video' },
+    FIRST_ENTRY => 0,
+    0 => 'HEVCConfigurationVersion',
+    1 => {
+        Name => 'GeneralProfileSpace',
+        Mask => 0xc0,
+        PrintConv => { 0 => 'Conforming' },
+    },
+    1.1 => {
+        Name => 'GeneralTierFlag',
+        Mask => 0x20,
+        PrintConv => {
+            0 => 'Main Tier',
+            1 => 'High Tier',
+        },
+    },
+    1.2 => {
+        Name => 'GeneralProfileIDC',
+        Mask => 0x1f,
+        PrintConv => {
+            0 => 'No Profile',
+            1 => 'Main',
+            2 => 'Main 10',
+            3 => 'Main Still Picture',
+            4 => 'Format Range Extensions',
+            5 => 'High Throughput',
+            6 => 'Multiview Main',
+            7 => 'Scalable Main',
+            8 => '3D Main',
+            9 => 'Screen Content Coding Extensions',
+            10 => 'Scalable Format Range Extensions',
+            11 => 'High Throughput Screen Content Coding Extensions',
+        },
+    },
+    2 => {
+        Name => 'GenProfileCompatibilityFlags',
+        Format => 'int32u',
+        PrintConv => { BITMASK => {
+            31 => 'No Profile',             # (bit 0 in stream)
+            30 => 'Main',                   # (bit 1 in stream)
+            29 => 'Main 10',                # (bit 2 in stream)
+            28 => 'Main Still Picture',     # (bit 3 in stream)
+            27 => 'Format Range Extensions',# (...)
+            26 => 'High Throughput',
+            25 => 'Multiview Main',
+            24 => 'Scalable Main',
+            23 => '3D Main',
+            22 => 'Screen Content Coding Extensions',
+            21 => 'Scalable Format Range Extensions',
+            20 => 'High Throughput Screen Content Coding Extensions',
+        }},
+    },
+    6 => {
+        Name => 'ConstraintIndicatorFlags',
+        Format => 'int8u[6]',
+    },
+    12 => {
+        Name => 'GeneralLevelIDC',
+        PrintConv => 'sprintf("%d (level %.1f)", $val, $val/30)',
+    },
+    13 => {
+        Name => 'MinSpatialSegmentationIDC',
+        Format => 'int16u',
+        Mask => 0x0fff,
+    },
+    15 => {
+        Name => 'ParallelismType',
+        Mask => 0x03,
+    },
+    16 => {
+        Name => 'ChromaFormat',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'Monochrome',
+            1 => '4:2:0',
+            2 => '4:2:2',
+            3 => '4:4:4',
+        },
+    },
+    17 => {
+        Name => 'BitDepthLuma',
+        Mask => 0x07,
+        ValueConv => '$val + 8',
+    },
+    18 => {
+        Name => 'BitDepthChroma',
+        Mask => 0x07,
+        ValueConv => '$val + 8',
+    },
+    19 => {
+        Name => 'AverageFrameRate',
+        Format => 'int16u',
+        ValueConv => '$val / 256',
+    },
+    21 => {
+        Name => 'ConstantFrameRate',
+        Mask => 0xc0,
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Constant Frame Rate',
+            2 => 'Each Temporal Layer is Constant Frame Rate',
+        },
+    },
+    21.1 => {
+        Name => 'NumTemporalLayers',
+        Mask => 0x38,
+    },
+    21.2 => {
+        Name => 'TemporalIDNested',
+        Mask => 0x04,
+        PrintConv => { 0 => 'No', 1 => 'Yes' },
+    },
+    #21.3 => {
+    #    Name => 'NALUnitLengthSize',
+    #    Mask => 0x03,
+    #    ValueConv => '$val + 1',
+    #    PrintConv => { 1 => '8-bit', 2 => '16-bit', 4 => '32-bit' },
+    #},
+    #22 => 'NumberOfNALUnitArrays',
+    # (don't decode the NAL unit arrays)
+);
+
+# HEVC configuration (ref https://aomediacodec.github.io/av1-isobmff/#av1codecconfigurationbox)
+%Image::ExifTool::QuickTime::AV1Config = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 2 => 'Video' },
+    FIRST_ENTRY => 0,
+    0 => {
+        Name => 'AV1ConfigurationVersion',
+        Mask => 0x7f,
+    },
+    1.0 => {
+        Name => 'SeqProfile',
+        Mask => 0xe0,
+        Unknown => 1,
+    },
+    1.1 => {
+        Name => 'SeqLevelIdx0',
+        Mask => 0x1f,
+        Unknown => 1,
+    },
+    2.0 => {
+        Name => 'SeqTier0',
+        Mask => 0x80,
+        Unknown => 1,
+    },
+    2.1 => {
+        Name => 'HighBitDepth',
+        Mask => 0x40,
+        Unknown => 1,
+    },
+    2.2 => {
+        Name => 'TwelveBit',
+        Mask => 0x20,
+        Unknown => 1,
+    },
+    2.3 => {
+        Name => 'ChromaFormat', # (Monochrome+SubSamplingX+SubSamplingY)
+        Notes => 'bits: 0x04 = Monochrome, 0x02 = SubSamplingX, 0x01 = SubSamplingY',
+        Mask => 0x1c,
+        PrintConv => {
+            0x00 => 'YUV 4:4:4',
+            0x02 => 'YUV 4:2:2',
+            0x03 => 'YUV 4:2:0',
+            0x07 => 'Monochrome 4:0:0',
+        },
+    },
+    2.4 => {
+        Name => 'ChromaSamplePosition',
+        Mask => 0x03,
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Vertical',
+            2 => 'Colocated',
+            3 => '(reserved)',
+        },
+    },
+    3 => {
+        Name => 'InitialDelaySamples',
+        RawConv => '$val & 0x10 ? undef : ($val & 0x0f) + 1',
+        Unknown => 1,
+    },
+);
+
+%Image::ExifTool::QuickTime::ItemRef = (
+    PROCESS_PROC => \&ProcessMOV,
+    WRITE_PROC => \&WriteQuickTime,
+    GROUPS => { 2 => 'Image' },
+    # (Note: ExifTool's ItemRefVersion may be used to test the iref version number)
+    NOTES => q{
+        The Item reference entries listed in the table below contain information about
+        the associations between items in the file.  This information is used by
+        ExifTool, but these entries are not extracted as tags.
+    },
+    dimg => { Name => 'DerivedImageRef',   RawConv => 'undef' },
+    thmb => { Name => 'ThumbnailRef',      RawConv => 'undef' },
+    auxl => { Name => 'AuxiliaryImageRef', RawConv => 'undef' },
+    cdsc => {
+        Name => 'ContentDescribes',
+        RawConv => \&ParseContentDescribes,
+        WriteHook => \&ParseContentDescribes,
+    },
+);
+
+%Image::ExifTool::QuickTime::ItemInfo = (
+    PROCESS_PROC => \&ProcessMOV,
+    WRITE_PROC => \&WriteQuickTime,
+    GROUPS => { 2 => 'Image' },
+    # avc1 - AVC image
+    # hvc1 - HEVC image
+    # lhv1 - L-HEVC image
+    # infe - ItemInformationEntry
+    # infe types: avc1,hvc1,lhv1,Exif,xml1,iovl(overlay image),grid,mime,hvt1(tile image)
+    infe => {
+        Name => 'ItemInfoEntry',
+        RawConv => \&ParseItemInfoEntry,
+        WriteHook => \&ParseItemInfoEntry,
+        Notes => 'parsed, but not extracted as a tag',
+    },
 );
 
@@ -1188,7 +2938,47 @@
 %Image::ExifTool::QuickTime::TrackRef = (
     PROCESS_PROC => \&ProcessMOV,
-    GROUPS => { 2 => 'Video' },
-    chap => { Name => 'ChapterList', Format => 'int32u' },
-    # also: tmcd, sync, scpt, ssrc, iTunesInfo
+    GROUPS => { 1 => 'Track#', 2 => 'Video' },
+    chap => { Name => 'ChapterListTrackID', Format => 'int32u' },
+    tmcd => { Name => 'TimeCode', Format => 'int32u' },
+    mpod => { #PH (FLIR MP4)
+        Name => 'ElementaryStreamTrack',
+        Format => 'int32u',
+        ValueConv => '$val =~ s/^1 //; $val',  # (why 2 numbers? -- ignore the first if "1")
+    },
+    # also: sync, scpt, ssrc, iTunesInfo
+    cdsc => {
+        Name => 'ContentDescribes',
+        Format => 'int32u',
+        PrintConv => '"Track $val"',
+    },
+    # cdep (Structural Dependency QT tag?)
+);
+
+# track aperture mode dimensions atoms
+# (ref https://developer.apple.com/library/mac/#documentation/QuickTime/QTFF/QTFFChap2/qtff2.html)
+%Image::ExifTool::QuickTime::TrackAperture = (
+    PROCESS_PROC => \&ProcessMOV,
+    GROUPS => { 1 => 'Track#', 2 => 'Video' },
+    clef => {
+        Name => 'CleanApertureDimensions',
+        Format => 'fixed32u',
+        Count => 3,
+        ValueConv => '$val =~ s/^.*? //; $val', # remove flags word
+        PrintConv => '$val =~ tr/ /x/; $val',
+    },
+    prof => {
+        Name => 'ProductionApertureDimensions',
+        Format => 'fixed32u',
+        Count => 3,
+        ValueConv => '$val =~ s/^.*? //; $val',
+        PrintConv => '$val =~ tr/ /x/; $val',
+    },
+    enof => {
+        Name => 'EncodedPixelsDimensions',
+        Format => 'fixed32u',
+        Count => 3,
+        ValueConv => '$val =~ s/^.*? //; $val',
+        PrintConv => '$val =~ tr/ /x/; $val',
+    },
 );
 
@@ -1197,16 +2987,51 @@
 %Image::ExifTool::QuickTime::ItemList = (
     PROCESS_PROC => \&ProcessMOV,
-    GROUPS => { 2 => 'Audio' },
+    WRITE_PROC => \&WriteQuickTime,
+    CHECK_PROC => \&CheckQTValue,
+    WRITABLE => 1,
+    PREFERRED => 2, # (preferred over UserData and Keys tags when writing)
+    FORMAT => 'string',
+    GROUPS => { 1 => 'ItemList', 2 => 'Audio' },
+    WRITE_GROUP => 'ItemList',
+    LANG_INFO => \&GetLangInfo,
     NOTES => q{
-        As well as these tags, the 'mdta' handler uses numerical tag ID's which are
-        added dynamically to this table after processing the Meta Keys information.
+        This is the preferred location for creating new QuickTime tags.  Tags in
+        this table support alternate languages which are accessed by adding a
+        3-character ISO 639-2 language code and an optional ISO 3166-1 alpha 2
+        country code to the tag name (eg. "ItemList:Title-fra" or
+        "ItemList::Title-fra-FR").  When creating a new Meta box to contain the
+        ItemList directory, by default ExifTool adds an 'mdir' (Metadata) Handler
+        box because Apple software may ignore ItemList tags otherwise, but the API
+        L<QuickTimeHandler|../ExifTool.html#QuickTimeHandler> option may be set to 0 to avoid this.
     },
     # in this table, binary 1 and 2-byte "data"-type tags are interpreted as
-    # int8u and int16u.  Multi-byte binary "data" tags are extracted as binary data
+    # int8u and int16u.  Multi-byte binary "data" tags are extracted as binary data.
+    # (Note that the Preferred property is set to 0 for some tags to prevent them
+    #  from being created when a same-named tag already exists in the table)
     "\xa9ART" => 'Artist',
     "\xa9alb" => 'Album',
+    "\xa9aut" => { Name => 'Author', Avoid => 1, Groups => { 2 => 'Author' } }, #forum10091 ('auth' is preferred)
     "\xa9cmt" => 'Comment',
-    "\xa9com" => 'Composer',
-    "\xa9day" => { Name => 'Year', Groups => { 2 => 'Time' } },
+    "\xa9com" => { Name => 'Composer', Avoid => 1, }, # ("\xa9wrt" is preferred in ItemList)
+    "\xa9day" => {
+        Name => 'ContentCreateDate',
+        Groups => { 2 => 'Time' },
+        Shift => 'Time',
+        # handle values in the form "2010-02-12T13:27:14-0800"
+        ValueConv => q{
+            require Image::ExifTool::XMP;
+            $val =  Image::ExifTool::XMP::ConvertXMPDate($val);
+            $val =~ s/([-+]\d{2})(\d{2})$/$1:$2/; # add colon to timezone if necessary
+            return $val;
+        },
+        ValueConvInv => q{
+            require Image::ExifTool::XMP;
+            $val =  Image::ExifTool::XMP::FormatXMPDate($val);
+            $val =~ s/([-+]\d{2}):(\d{2})$/$1$2/; # remove time zone colon
+            return $val;
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,1)', # (add time zone if it didn't exist)
+    },
     "\xa9des" => 'Description', #4
     "\xa9enc" => 'EncodedBy', #10
@@ -1215,24 +3040,54 @@
     "\xa9lyr" => 'Lyrics',
     "\xa9nam" => 'Title',
-    # "\xa9st3" ? #10
     "\xa9too" => 'Encoder',
     "\xa9trk" => 'Track',
     "\xa9wrt" => 'Composer',
+#
+# the following tags written by AtomicParsley 0.9.6
+# (ref https://exiftool.org/forum/index.php?topic=11455.0)
+#
+    "\xa9st3" => 'Subtitle',
+    "\xa9con" => 'Conductor',
+    "\xa9sol" => 'Soloist',
+    "\xa9arg" => 'Arranger',
+    "\xa9ope" => 'OriginalArtist',
+    "\xa9dir" => 'Director',
+    "\xa9ard" => 'ArtDirector',
+    "\xa9sne" => 'SoundEngineer',
+    "\xa9prd" => 'Producer',
+    "\xa9xpd" => 'ExecutiveProducer',
+    sdes      => 'StoreDescription',
+#
     '----' => {
         Name => 'iTunesInfo',
         SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::iTunesInfo' },
     },
-    aART => 'AlbumArtist',
-    covr => 'CoverArt',
+    aART => { Name => 'AlbumArtist', Groups => { 2 => 'Author' } },
+    covr => { Name => 'CoverArt',    Groups => { 2 => 'Preview' } },
     cpil => { #10
         Name => 'Compilation',
+        Format => 'int8u', #27 (ref 23 contradicts what AtomicParsley actually writes, which is int8s)
+        Writable => 'int8s',
         PrintConv => { 0 => 'No', 1 => 'Yes' },
     },
     disk => {
         Name => 'DiskNumber',
-        ValueConv => 'length($val) >= 6 ? join(" of ",unpack("x2nn",$val)) : \$val',
+        Format => 'undef',  # (necessary to prevent decoding as string!)
+        ValueConv => q{
+            return \$val unless length($val) >= 6;
+            my @a = unpack 'x2nn', $val;
+            return $a[1] ? join(' of ', @a) : $a[0];
+        },
+        ValueConvInv => q{
+            my @a = $val =~ /\d+/g;
+            return undef if @a == 0 or @a > 2;
+            push @a, 0 if @a == 1;
+            return pack('n3', 0, @a);
+        },
     },
     pgap => { #10
         Name => 'PlayGap',
+        Format => 'int8u', #23
+        Writable => 'int8s', #27
         PrintConv => {
             0 => 'Insert Gap',
@@ -1242,9 +3097,24 @@
     tmpo => {
         Name => 'BeatsPerMinute',
-        Format => 'int16u', # marked as boolean but really int16u in my sample
+        # marked as boolean but really int16u in my sample
+        # (but written as int16s by iTunes and AtomicParsley, ref forum11506)
+        Format => 'int16u',
+        Writable => 'int16s',
     },
     trkn => {
         Name => 'TrackNumber',
-        ValueConv => 'length($val) >= 6 ? join(" of ",unpack("x2nn",$val)) : \$val',
+        Format => 'undef',  # (necessary to prevent decoding as string!)
+        ValueConv => q{
+            return \$val unless length($val) >= 6;
+            my @a = unpack 'x2nn', $val;
+            return $a[1] ? join(' of ', @a) : $a[0];
+        },
+        # (see forum11501 for discussion about the format used)
+        ValueConvInv => q{
+            my @a = $val =~ /\d+/g;
+            return undef if @a == 0 or @a > 2;
+            push @a, 0 if @a == 1;
+            return pack('n4', 0, @a, 0);
+        },
     },
 #
@@ -1254,4 +3124,6 @@
     akID => { #10
         Name => 'AppleStoreAccountType',
+        Format => 'int8u', #24
+        Writable => 'int8s', #27
         PrintConv => {
             0 => 'iTunes',
@@ -1259,9 +3131,10 @@
         },
     },
-    albm => 'Album', #(ffmpeg source)
+    albm => { Name => 'Album', Avoid => 1 }, #(ffmpeg source)
     apID => 'AppleStoreAccount',
     atID => { #10 (or TV series)
         Name => 'AlbumTitleID',
         Format => 'int32u',
+        Writable => 'int32s', #27
     },
     auth => { Name => 'Author', Groups => { 2 => 'Author' } },
@@ -1270,10 +3143,16 @@
         Name => 'AppleStoreCatalogID',
         Format => 'int32u',
+        Writable => 'int32s', #27
     },
     cprt => { Name => 'Copyright', Groups => { 2 => 'Author' } },
-    dscp => 'Description',
-    desc => 'Description', #7
+    dscp => { Name => 'Description', Avoid => 1 },
+    desc => { Name => 'Description', Avoid => 1 }, #7
     gnre => { #10
         Name => 'Genre',
+        Avoid => 1,
+        # (Note: see https://exiftool.org/forum/index.php?topic=11537.0)
+        Format => 'undef',
+        ValueConv => 'unpack("n",$val)',
+        ValueConvInv => '$val =~ /^\d+$/ ? pack("n",$val) : undef',
         PrintConv => q{
             return $val unless $val =~ /^\d+$/;
@@ -1281,4 +3160,11 @@
             Image::ExifTool::ID3::PrintGenre($val - 1); # note the "- 1"
         },
+        PrintConvInv => q{
+            return $val if $val =~ /^[0-9]+$/;
+            require Image::ExifTool::ID3;
+            my $id = Image::ExifTool::ID3::GetGenreID($val);
+            return unless defined $id and $id =~ /^\d+$/;
+            return $id + 1;
+        }, 
     },
     egid => 'EpisodeGlobalUniqueID', #7
